#581 force_rtp_proxy bug

ver 1.5.x
closed-accepted
modules (357)
5
2009-07-02
2009-06-29
No

force_rtp_proxy seems to handle re-invite wrong, resulting in one-way-audio.

Discussion

  • Daniel-Constantin Mierla

    When is this happening?

     
  • Marcus Hunger

    Marcus Hunger - 2009-06-30

    happens when i handle a reinvite with rtpproxy_offer("l")

     
  • Nobody/Anonymous

    in detail, the sdp is rewritten with the wrong port for this direction of the session. it's the same as the answer's which does not work. to build the query for the rtp-proxy from- and to-tag the have to be reversed in this case.

     
  • Klaus Darilion

    Klaus Darilion - 2009-07-01

    do you have a SIP trace? Is it maybe related to late offer (SDP in 200 OK and ACK)? Does the bug happens always or only if the reINVITE is sent by the callee?

     
  • Marcus Hunger

    Marcus Hunger - 2009-07-01

    sdp is in invite and 200 ok. the thing is, nearly the same config still worked in 1.2-branch, but after an upgrade to 1.4 it stopped.

    it happens always, no matter if the callee or caller does the reinvite.

    the following trace shows what happens. the rtpproxy-port in invite and reply is 41324. they must differ as they are used for different media-streams.

    217.10.1.1 - sip-proxy & rtpproxy
    172.20.21.2 - sip-proxy doing rtpproxy_* stuff
    217.10.66.165 - uac
    217.10.1.2 - uas

    U 217.10.1.1:5060 -> 172.20.21.2:5060
    INVITE sip:3993942p0@217.10.1.2 SIP/2.0.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    Route: <sip:172.20.21.2;lr=on>.
    CSeq: 4 INVITE.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    Contact: <sip:3993942e1@217.10.66.165:61020>.
    Allow: INVITE, ACK, BYE, CANCEL, OPTIONS, INFO, MESSAGE, SUBSCRIBE, NOTIFY, PRACK, UPDATE, REFER.
    User-Agent: PolycomSoundPointIP-SPIP_650-UA/2.1.2.0078.
    Supported: 100rel,replaces.
    Allow-Events: talk,hold,conference.
    Max-Forwards: 69.
    Content-Type: application/sdp.
    Content-Length: 297.
    X-hint: rr-enforced.
    X-nathint: nat.
    .
    v=0.
    o=- 1246290867 1246290869 IN IP4 192.168.234.24.
    s=Polycom IP Phone.
    c=IN IP4 192.168.234.24.
    t=0 0.
    m=audio 2262 RTP/AVP 9 0 8 18 101.
    a=sendrecv.
    a=rtpmap:9 G722/8000.
    a=rtpmap:0 PCMU/8000.
    a=rtpmap:8 PCMA/8000.
    a=rtpmap:18 G729/8000.
    a=rtpmap:101 telephone-event/8000.
    a=direction:active.

    #
    U 172.20.21.2:5060 -> 217.10.1.1:5060
    SIP/2.0 100 Giving a try.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    CSeq: 4 INVITE.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    Content-Length: 0.
    .

    #
    U 172.20.21.2:5060 -> 217.10.1.2:5060
    INVITE sip:3993942p0@217.10.1.2 SIP/2.0.
    Via: SIP/2.0/UDP 172.20.21.2;branch=z9hG4bKe2fc.9dcfa89.0.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    CSeq: 4 INVITE.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    Contact: <sip:3993942e1@217.10.66.165:61020>.
    Allow: INVITE, ACK, BYE, CANCEL, OPTIONS, INFO, MESSAGE, SUBSCRIBE, NOTIFY, PRACK, UPDATE, REFER.
    User-Agent: PolycomSoundPointIP-SPIP_650-UA/2.1.2.0078.
    Supported: 100rel,replaces.
    Allow-Events: talk,hold,conference.
    Max-Forwards: 68.
    Content-Type: application/sdp.
    Content-Length: 315.
    X-hint: rr-enforced.
    X-nathint: nat.
    .
    v=0.
    o=- 1246290867 1246290869 IN IP4 192.168.234.24.
    s=Polycom IP Phone.
    c=IN IP4 217.10.1.1.
    t=0 0.
    m=audio 41324 RTP/AVP 9 0 8 18 101.
    a=sendrecv.
    a=rtpmap:9 G722/8000.
    a=rtpmap:0 PCMU/8000.
    a=rtpmap:8 PCMA/8000.
    a=rtpmap:18 G729/8000.
    a=rtpmap:101 telephone-event/8000.
    a=direction:active.
    a=nortpproxy:yes.

    #
    U 217.10.1.2:5060 -> 172.20.21.2:5060
    SIP/2.0 100 Trying.
    Via: SIP/2.0/UDP 172.20.21.2;branch=z9hG4bKe2fc.9dcfa89.0;received=172.20.21.2.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    CSeq: 4 INVITE.
    Allow: INVITE, ACK, CANCEL, OPTIONS, BYE, REFER, SUBSCRIBE, NOTIFY.
    Supported: replaces, timer.
    Contact: <sip:3993942p0@217.10.1.2>.
    Content-Length: 0.
    .

    #
    U 217.10.1.2:5060 -> 172.20.21.2:5060
    SIP/2.0 200 OK.
    Via: SIP/2.0/UDP 172.20.21.2;branch=z9hG4bKe2fc.9dcfa89.0;received=172.20.21.2.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    CSeq: 4 INVITE.
    Allow: INVITE, ACK, CANCEL, OPTIONS, BYE, REFER, SUBSCRIBE, NOTIFY.
    Supported: replaces, timer.
    Contact: <sip:3993942p0@217.10.1.2>.
    Content-Type: application/sdp.
    Content-Length: 329.
    .
    v=0.
    o=root 647471219 647471221 IN IP4 217.10.1.2.
    s=sipgate VoIP GW.
    c=IN IP4 217.10.1.2.
    t=0 0.
    m=audio 17732 RTP/AVP 8 0 18 101.
    a=rtpmap:8 PCMA/8000.
    a=rtpmap:0 PCMU/8000.
    a=rtpmap:18 G729/8000.
    a=fmtp:18 annexb=no.
    a=rtpmap:101 telephone-event/8000.
    a=fmtp:101 0-16.
    a=silenceSupp:off - - - -.
    a=ptime:20.
    a=sendrecv.

    ##
    U 172.20.21.2:5060 -> 217.10.1.1:5060
    SIP/2.0 200 OK.
    Via: SIP/2.0/UDP 217.10.1.1:5060;branch=z9hG4bK78fccbad7757B75A.
    Via: SIP/2.0/UDP 192.168.234.24;rport=61020;received=217.10.66.165;branch=z9hG4bK78fccbad7757B75A.
    From: "Erika" <sip:3993942e1@sipgate.de>;tag=D6DBB0FD-C198C6EA.
    To: <sip:10@sipgate.de;user=phone>;tag=as3804b1ae.
    Call-ID: e521bbee-f129e0af-f6e95884@192.168.234.24.
    CSeq: 4 INVITE.
    Allow: INVITE, ACK, CANCEL, OPTIONS, BYE, REFER, SUBSCRIBE, NOTIFY.
    Supported: replaces, timer.
    Contact: <sip:3993942p0@217.10.1.2>.
    Content-Type: application/sdp.
    Content-Length: 347.
    .
    v=0.
    o=root 647471219 647471221 IN IP4 217.10.1.2.
    s=sipgate VoIP GW.
    c=IN IP4 217.10.1.1.
    t=0 0.
    m=audio 41324 RTP/AVP 8 0 18 101.
    a=rtpmap:8 PCMA/8000.
    a=rtpmap:0 PCMU/8000.
    a=rtpmap:18 G729/8000.
    a=fmtp:18 annexb=no.
    a=rtpmap:101 telephone-event/8000.
    a=fmtp:101 0-16.
    a=silenceSupp:off - - - -.
    a=ptime:20.
    a=sendrecv.
    a=nortpproxy:yes.

     
  • Daniel-Constantin Mierla

    Patch applied to 1.5. Thanks.

     
  • Daniel-Constantin Mierla

    • assigned_to: nobody --> miconda
    • status: open --> closed-accepted
     

Log in to post a comment.